<template>
    <v-layout color="#f8f8f8">
        <v-dialog v-model="exportmodal" width="420">
        <v-card >
            <v-card-title class="headline justify-center">Export Data</v-card-title>
            <center><v-divider width="80%" ></v-divider>
            <p style="margin-top:5px;">Please select month that you want to export.</p></center>
            <v-layout style="padding:0px 0  0px 0px;" justify-center>
            <!-- <v-date-picker
                :disabled-years="disabled"
                v-model="months"
                type="month"
                multiple
                max
                next-year-aria-label
                no-title
                reactive
            ></v-date-picker>  -->
            <v-flex xs7>
                <v-menu
                ref="menu"
                v-model="menu"
                :close-on-content-click="false"
                :nudge-right="40"
                lazy
                transition="scale-transition"
                offset-y
                full-width
                min-width="290px"
            >
                <template v-slot:activator="{ on }">
                <v-combobox
                    v-model="months"
                    multiple
                    chips
                    small-chips
                    label="Select month"
                    prepend-icon="event"
                    readonly
                    v-on="on"
                    class="exportmodal"
                ></v-combobox>
                </template>
                <v-date-picker
                v-model="months"
                multiple no-title scrollable
                type="month" color="#538795"
                :min="monthlimit"
                :max="today">
                <!-- <v-spacer></v-spacer>
                <v-btn flat color="primary" @click="menu = false">Cancel</v-btn>
                <v-btn flat color="primary" @click="$refs.menu.save(months)">OK</v-btn> -->
                </v-date-picker>
            </v-menu>
            </v-flex>
            </v-layout>
            <v-layout class="justify-center">
            <v-card-actions >
            <br><br><br>
            <v-spacer></v-spacer>
            <!-- <v-btn icon style="color:#538795;" text @click="dialogexport=false">PDF<v-icon> mdi-file-pdf</v-icon></v-btn>&nbsp;&nbsp;&nbsp;&nbsp; -->
            <v-btn icon style="color:#538795;" color="white" text @click="onExport">EXCEL<v-icon> mdi-file-excel</v-icon></v-btn>
            </v-card-actions>
            </v-layout>
        </v-card>
        </v-dialog>
    </v-layout>
</template>
<script>
import { sync } from 'vuex-pathify'
import XLSX from 'xlsx'
import moment from 'moment'
export default {
  data () {
    return {
      today: new Date().toISOString().substr(0, 7),
      monthlimit: moment(new Date()).subtract(6, 'months').format('YYYY-MM'),
      months: [],
      menu: false,
      alltransactions: '',
      datafromdb: '',
      dataexport: []
    }
  },
  computed: {
    exportmodal: sync('exportmodal'),
    exportfrom: sync('exportfrom')
  },
  methods: {
    async onExport () {
      await this.getexportdata()
      for (var i = 0; i < (this.datafromdb).length; i++) {
        for (var a = 0; a < (this.datafromdb[i]).length; a++) {
          this.dataexport.push(this.datafromdb[i][a])
        }
      }
      const dataWS = XLSX.utils.json_to_sheet(this.dataexport)
      const wb = XLSX.utils.book_new()
      XLSX.utils.book_append_sheet(wb, dataWS)

      if (this.exportfrom == 'Incomes' && this.months.length > 0) {
        XLSX.writeFile(wb, 'Incomes Report.xlsx')
      } else if (this.exportfrom == 'Paid' && this.months.length > 0) {
        XLSX.writeFile(wb, 'Paid Bill Report.xlsx')
      } else if (this.exportfrom == 'ewht' && this.months.length > 0) {
        XLSX.writeFile(wb, 'EWHT Report.xlsx')
      } else if (this.exportfrom == 'Transaction' && this.months.length > 0) {
        XLSX.writeFile(wb, 'Transaction Report.xlsx')
      } else {

      }
      this.exportmodal = false
      this.months = []
      this.dataexport = []
    },
    // createPDF () {
    //     let pdfName = 'test';
    //     var doc = new jsPDF();
    //     doc.text(this.dataWS, 10, 10);
    //     doc.save(pdfName + '.pdf');
    // },
    // savePdf(){
    //      let self = this;
    //     let jsonString = JSON.stringify(self.spread.toJSON());
    //     let printSpread = new GC.Spread.Sheets.Workbook();
    //     printSpread.fromJSON(JSON.parse(jsonString));
    //     printSpread.savePDF(function(blob) {
    //             // window.open(URL.createObjectURL(blob))
    //             FaverSaver.saveAs(blob,  'Hello.pdf')
    //             }, function(error) {
    //              console.log(error);
    //             }, {
    //             title: 'Print',
    //         });
    //  },
    async getexportdata () {
      if (!this.exportfrom) {
        alert('Please try again')
      } else if (this.months.length === 0) {
        alert('Please select month')
      } else {
        try {
          if (this.exportfrom === 'Incomes') {
            var { data } = await this.axios.post(`${process.env.VUE_APP_APIHOST}/get_report_income`,
              { invoiceDate: this.months },
              { headers: { Authorization: this.$cookies.get('token') } })
            this.datafromdb = data
          } else if (this.exportfrom === 'Paid') {
            var { data } = await this.axios.post(`${process.env.VUE_APP_APIHOST}/get_report_paid`,
              { invoiceDate: this.months },
              { headers: { Authorization: this.$cookies.get('token') } })
            this.datafromdb = data
          } else if (this.exportfrom === 'ewht') {
            var { data } = await this.axios.post(`${process.env.VUE_APP_APIHOST}/get_report_wht`,
              { invoiceDate: this.months },
              { headers: { Authorization: this.$cookies.get('token') } })
            this.datafromdb = data
          } else if (this.exportfrom === 'Transaction') {
            var { data } = await this.axios.post(`${process.env.VUE_APP_APIHOST}/get_report_transaction`,
              { invoiceDate: this.months },
              { headers: { Authorization: this.$cookies.get('token') } })
            this.datafromdb = data
          }
          // this.dialogexport = false
        } catch (error) {
          console.log(error.message)
        }
      }
    }
  },
  watch: {
    // months(){
    //     console.log(this.months);
    // }
    exportmodal () {
      if (this.exportmodal == false) {
        this.months = []
      }
    }
  }
  // created () {
  //     this.onClose()
  // }
}
</script>

<style >
.exportmodal .v-input__icon--prepend .v-icon {
    color: #538795;
}
</style>
